#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_outfile=EzBmpButtonDemo.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Run_After=C:\Programme\AutoIt3\SciTE\AutoIt3Wrapper\ResHacker.exe -script bitmaps.rh
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****


#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <ButtonConstants.au3>

#include "EzBmpButton.au3"

; Konstanten fr Ressourcen-Identifizierer
Global Enum $IDB_BTN_1 = 100, _
			$IDB_BTN_2, _
			$IDB_BTN_3, _
			$IDB_BTN_4 = 110, _
			$IDB_BTN_5, _
			$IDB_BTN_6, _
			$IDB_BTN_7 = 120, _
			$IDB_BTN_8


Global $ID_BUTTON_1, $ID_BUTTON_2, $ID_BUTTON_3, $ID_BUTTON_4

Global $hButton1, $hButton2, $hButton3, $hButton4

ConsoleWrite ("-> ### Beginn - Bitmap Button Test ! ###" & @crlf)

If (@Compiled) Then
	Call ("ExampleRes")
Else
	Call ("ExampleDir")
EndIf	

Func ExampleDir ( )

	Local $hwndTest, $iMsg


	$hwndTest = GUICreate ("Bitmap Button Test", _
							600, 480, -1, -1, _
							BitOR ($WS_OVERLAPPEDWINDOW, $WS_CLIPCHILDREN))

	$ID_BUTTON_1 = CreateEzBmpButton ("", _
								   20, 30, 100, 30, _
								   $hwndTest, _
								   '.\Normal_1.bmp', _
								   '.\Hover_1.bmp', _
								   '.\Press_1.bmp')

	$ID_BUTTON_2 = CreateEzBmpButton ("", _
								   20, 80, 100, 30, _
								   $hwndTest, _
								   '.\Normal_2.bmp', _
								   '.\Hover_2.bmp', _
								   '.\Press_2.bmp')

	$ID_BUTTON_3 = CreateEzBmpButton ("Button 3", _
								   20, 130, 100, 30, _
								   $hwndTest, _
								   '.\Normal.bmp', _
								   '.\Hover.bmp', _
								   '.\Hover.bmp', _
								   0x00FF00) ; green text

	$ID_BUTTON_4 = GUICtrlCreateButton ("&Button 4", _
										20, 180, 100, 30, _
										BitOR ($WS_CHILD, $WS_VISIBLE, $WS_TABSTOP, $WS_CLIPSIBLINGS, $BS_NOTIFY))

	$hButton4    = GUICtrlGetHandle ($ID_BUTTON_4)


;~ 	GUIRegisterMsg ($WM_COMMAND   , "WM_COMMAND")
;~ 	GUIRegisterMsg ($WM_NOTIFY    , "WM_NOTIFY")

	GUISetState (@SW_SHOW, $hwndTest)

	While (True)
		
		$iMsg = GUIGetMsg ( )
		
		Switch ($iMsg)
			Case $GUI_EVENT_CLOSE
				 ExitLoop
			Case $ID_BUTTON_1
				 MsgBox (266304, "Info", _
					StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", $iMsg))
					
			Case $ID_BUTTON_2
				 MsgBox (266304, "Info", _
					StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", $iMsg))
					
			Case $ID_BUTTON_3
				 MsgBox (266304, "Info", _
					StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", $iMsg))
					
			Case $ID_BUTTON_4
				 MsgBox (266304, "Info", _
					StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", $iMsg))
		EndSwitch
	WEnd

EndFunc

Func ExampleRes ( )

	Local $hwndTest, $iMsg
	

	$hwndTest = GUICreate ("Bitmap Button Test - Resource", _
							600, 480, -1, -1, _
							BitOR ($WS_OVERLAPPEDWINDOW, $WS_CLIPCHILDREN))

	$ID_BUTTON_1 = CreateEzBmpButton ("", _
								   20, 30, 100, 30, _
								   $hwndTest, _
								   $IDB_BTN_1, _
								   $IDB_BTN_2, _
								   $IDB_BTN_3)

	$ID_BUTTON_2 = CreateEzBmpButton ("", _
								   20, 80, 100, 30, _
								   $hwndTest, _
								   $IDB_BTN_4, _
								   $IDB_BTN_5, _
								   $IDB_BTN_6)

	$ID_BUTTON_3 = CreateEzBmpButton ("Button 3", _
								   20, 130, 100, 30, _
								   $hwndTest, _
								   $IDB_BTN_7, _
								   $IDB_BTN_8, _
								   $IDB_BTN_8, _
								   0x00FF00) ; green text

	$ID_BUTTON_4 = GUICtrlCreateButton ("Button 4", _
										20, 180, 100, 30, _
										BitOR ($WS_CHILD, $WS_VISIBLE, $WS_TABSTOP, $WS_CLIPSIBLINGS, $BS_NOTIFY))

	$hButton4    = GUICtrlGetHandle ($ID_BUTTON_4)


	GUIRegisterMsg ($WM_COMMAND   , "WM_COMMAND")
	GUIRegisterMsg ($WM_NOTIFY    , "WM_NOTIFY")

	GUISetState (@SW_SHOW, $hwndTest)

	While (True)
		
		$iMsg = GUIGetMsg ( )
		
		Switch ($iMsg)
			Case $GUI_EVENT_CLOSE
				 ExitLoop
			Case $ID_BUTTON_1
				 MsgBox (266304, "Info", _
					StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", $iMsg))
					
			Case $ID_BUTTON_2
				 MsgBox (266304, "Info", _
					StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", $iMsg))
					
			Case $ID_BUTTON_3
				 MsgBox (266304, "Info", _
					StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", $iMsg))
					
			Case $ID_BUTTON_4
				 MsgBox (266304, "Info", _
					StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", $iMsg))
		EndSwitch
	WEnd

EndFunc

ConsoleWrite ("->  ### Ende - Bitmap Button Test ! ###" & @crlf)


Func WM_COMMAND ($hWnd, $uMsg, $wParam, $lParam)

	ConsoleWrite (">WM_COMMAND ("&$hWnd&", "&$uMsg&", "&$wParam&", "&$lParam&")" & @crlf)
;~ 	ConsoleWrite ("+>LOWORD(wParam) : "&LOWORD($wParam) & @crlf)
;~ 	ConsoleWrite ("+>HIWORD(wParam) : "&HIWORD($wParam) & @crlf)

	Switch (LOWORD($wParam))
		Case $ID_BUTTON_1
			 If (HIWORD($wParam) == $_BN_CLICKED) Then
				 If (@Compiled) Then
					 MsgBox (266304, "Info", StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)))
				 Else
					 ConsoleWrite (StringFormat (">Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)) & @crlf)
				 EndIf	
			 EndIf	
		Case $ID_BUTTON_2
			 If (HIWORD($wParam) == $_BN_CLICKED) Then
				 If (@Compiled) Then
					 MsgBox (266304, "Info", StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)))
				 Else
					 ConsoleWrite (StringFormat (">Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)) & @crlf)
				 EndIf	
			 EndIf	
		Case $ID_BUTTON_3
			 If (HIWORD($wParam) == $_BN_CLICKED) Then
				 If (@Compiled) Then
					 MsgBox (266304, "Info", StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)))
				 Else
					 ConsoleWrite (StringFormat (">Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)) & @crlf)
				 EndIf	
			 EndIf	
		Case $ID_BUTTON_4
			 If (HIWORD($wParam) == $_BN_CLICKED) Then
				 If (@Compiled) Then
					 MsgBox (266304, "Info", StringFormat ("Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)))
				 Else
					 ConsoleWrite (StringFormat (">Die Schaltflche mit der ID %d wurde gedrckt.", LOWORD($wParam)) & @crlf)
				 EndIf	
			 EndIf	
	EndSwitch
	
	Return 0

EndFunc

Func WM_NOTIFY ($hWnd, $uMsg, $wParam, $lParam)

	ConsoleWrite ("+>WM_NOTIFY ("&$hWnd&", "&$uMsg&", "&$wParam&", "&$lParam&")" & @crlf)
	
	Local $nmh = DllStructCreate ($NMHDR, $lParam)
	Local $code, $idFrom, $hwndFrom
	
	$code     = DllStructGetData ($nmh, "code")
	$idFrom   = DllStructGetData ($nmh, "idFrom")
	$hwndFrom = DllStructGetData ($nmh, "hwndFrom")
	
	Switch ($hwndFrom)
		
		Case $hButton1
			 ConsoleWrite ("+>code     : "&$code     & @crlf)
			 ConsoleWrite ("+>idFrom   : "&$idFrom   & @crlf)
			 ConsoleWrite ("+>hwndFrom : "&$hwndFrom & @crlf)
			 
		Case $hButton2
			 ConsoleWrite ("+>code     : "&$code     & @crlf)
			 ConsoleWrite ("+>idFrom   : "&$idFrom   & @crlf)
			 ConsoleWrite ("+>hwndFrom : "&$hwndFrom & @crlf)
			 
		Case $hButton3
			 ConsoleWrite ("+>code     : "&$code     & @crlf)
			 ConsoleWrite ("+>idFrom   : "&$idFrom   & @crlf)
			 ConsoleWrite ("+>hwndFrom : "&$hwndFrom & @crlf)
			 
		Case $hButton4
			 ConsoleWrite ("+>code     : "&$code     & @crlf)
			 ConsoleWrite ("+>idFrom   : "&$idFrom   & @crlf)
			 ConsoleWrite ("+>hwndFrom : "&$hwndFrom & @crlf)
			 
	EndSwitch
	
	Return 0

EndFunc


























